STACK_POINTER_START = $01000000 ; Full descending stack points to end of RAM + 1... Is it more compatible to make it so that it'll descend to $00FFFFFF rather than $FFFFFFFF?
CODE_START          = main

VECTOR_BUS_ERROR                            = unhandled_exception
VECTOR_ADDRESS_ERROR                        = unhandled_exception
VECTOR_ILLEGAL_INSTRUCTION                  = unhandled_exception
VECTOR_DIVISION_BY_ZERO                     = unhandled_exception
VECTOR_CHK_EXCEPTION                        = unhandled_exception
VECTOR_TRAPV_EXCEPTION                      = unhandled_exception
VECTOR_PRIVILEGE_VIOLATION_EXCEPTION        = unhandled_exception
VECTOR_TRACE_EXCEPTION                      = unhandled_exception
VECTOR_LINE_1010_EMULATOR                   = unhandled_exception
VECTOR_LINE_1111_EMULATOR                   = unhandled_exception
VECTOR_RESERVED_EXCEPTION                   = unhandled_exception
VECTOR_SPURIOUS_EXCEPTION                   = unhandled_exception
VECTOR_INTERRUPT_REQUEST_LEVEL_1            = unhandled_exception
VECTOR_INTERRUPT_REQUEST_LEVEL_2            = unhandled_exception
VECTOR_INTERRUPT_REQUEST_LEVEL_3            = unhandled_exception
VECTOR_INTERRUPT_REQUEST_LEVEL_4_VDP_HBLANK = hblank
VECTOR_INTERRUPT_REQUEST_LEVEL_5            = unhandled_exception
VECTOR_INTERRUPT_REQUEST_LEVEL_6_VDP_VBLANK = vblank
VECTOR_INTERRUPT_REQUEST_LEVEL_7            = unhandled_exception
VECTOR_TRAP_00_EXCEPTION                    = unhandled_exception
VECTOR_TRAP_01_EXCEPTION                    = unhandled_exception
VECTOR_TRAP_02_EXCEPTION                    = unhandled_exception
VECTOR_TRAP_03_EXCEPTION                    = unhandled_exception
VECTOR_TRAP_04_EXCEPTION                    = unhandled_exception
VECTOR_TRAP_05_EXCEPTION                    = unhandled_exception
VECTOR_TRAP_06_EXCEPTION                    = unhandled_exception
VECTOR_TRAP_07_EXCEPTION                    = unhandled_exception
VECTOR_TRAP_08_EXCEPTION                    = unhandled_exception
VECTOR_TRAP_09_EXCEPTION                    = unhandled_exception
VECTOR_TRAP_10_EXCEPTION                    = unhandled_exception
VECTOR_TRAP_11_EXCEPTION                    = unhandled_exception
VECTOR_TRAP_12_EXCEPTION                    = unhandled_exception
VECTOR_TRAP_13_EXCEPTION                    = unhandled_exception
VECTOR_TRAP_14_EXCEPTION                    = unhandled_exception
VECTOR_TRAP_15_EXCEPTION                    = unhandled_exception

        ; ROM Header.
        
        ; Bytes $08 to $FF are the Motorola 68000 exception vector table.

        org $00
        dc.l STACK_POINTER_START
        dc.l CODE_START
        dc.l VECTOR_BUS_ERROR
        dc.l VECTOR_ADDRESS_ERROR

        dc.l VECTOR_ILLEGAL_INSTRUCTION
        dc.l VECTOR_DIVISION_BY_ZERO
        dc.l VECTOR_CHK_EXCEPTION
        dc.l VECTOR_TRAPV_EXCEPTION

        dc.l VECTOR_PRIVILEGE_VIOLATION_EXCEPTION
        dc.l VECTOR_TRACE_EXCEPTION
        dc.l VECTOR_LINE_1010_EMULATOR
        dc.l VECTOR_LINE_1111_EMULATOR

        dc.l unhandled_exception
        dc.l unhandled_exception
        dc.l unhandled_exception
        dc.l unhandled_exception

        dc.l unhandled_exception
        dc.l unhandled_exception
        dc.l unhandled_exception
        dc.l unhandled_exception

        dc.l unhandled_exception
        dc.l unhandled_exception
        dc.l unhandled_exception
        dc.l unhandled_exception

        dc.l VECTOR_SPURIOUS_EXCEPTION
        dc.l VECTOR_INTERRUPT_REQUEST_LEVEL_1
        dc.l VECTOR_INTERRUPT_REQUEST_LEVEL_2
        dc.l VECTOR_INTERRUPT_REQUEST_LEVEL_3

        dc.l VECTOR_INTERRUPT_REQUEST_LEVEL_4_VDP_HBLANK
        dc.l VECTOR_INTERRUPT_REQUEST_LEVEL_5
        dc.l VECTOR_INTERRUPT_REQUEST_LEVEL_6_VDP_VBLANK
        dc.l VECTOR_INTERRUPT_REQUEST_LEVEL_7

        dc.l VECTOR_TRAP_00_EXCEPTION
        dc.l VECTOR_TRAP_01_EXCEPTION
        dc.l VECTOR_TRAP_02_EXCEPTION
        dc.l VECTOR_TRAP_03_EXCEPTION

        dc.l VECTOR_TRAP_04_EXCEPTION
        dc.l VECTOR_TRAP_05_EXCEPTION
        dc.l VECTOR_TRAP_06_EXCEPTION
        dc.l VECTOR_TRAP_07_EXCEPTION

        dc.l VECTOR_TRAP_08_EXCEPTION
        dc.l VECTOR_TRAP_09_EXCEPTION
        dc.l VECTOR_TRAP_10_EXCEPTION
        dc.l VECTOR_TRAP_11_EXCEPTION

        dc.l VECTOR_TRAP_12_EXCEPTION
        dc.l VECTOR_TRAP_13_EXCEPTION
        dc.l VECTOR_TRAP_14_EXCEPTION
        dc.l VECTOR_TRAP_15_EXCEPTION
        
        ; All other exceptions are FPU or MMU related and unhandled.

        org $100
        dc.b "SEGA MEGA DRIVE "              ; Console name
        dc.b "(C)MATT 2014.MAT"              ; Release date "(C)comp year.mon"
        dc.b "MATTS INST MAKER"              ; Domestic name
        org $150
        dc.b "MATTS INST MAKER"              ; International name
        org $180
        dc.b "GM 10101010-00"                ; Version string
        dc.w $1234                           ; Checksum (to be done later)
        dc.b "JD"                            ; IO Support? (What devices are supported... J is joypad? I wish I could find an explanation for this one.)
        org $1A0
        dc.l $00000000                       ; ROM start
        dc.l $0000FFFF                       ; ROM end
        dc.l $00FF0000                       ; RAM start
        dc.l $00FFFFFF                       ; RAM end
        dc.b $00,$00,$00                     ; SRAM enable magic numbers
        dc.b $20                             ; Unused 0x20
        dc.l $00000000                       ; SRAM start
        dc.l $00000000                       ; SRAM end
        dc.b "NOTES SECTION"                 ; Notes section.
        org $1F0
        dc.b "JUE"                           ; Region support.

; Header ends.

; Equates for the Mega Drive's memory mapped peripherals.
MM_VERSION_REGISTER              = $00A10000 ; Read only word long.

MM_CONTROLLER_1_DATA             = $00A10002
MM_CONTROLLER_2_DATA             = $00A10004
MM_EXPANSION_PORT_DATA           = $00A10006

MM_CONTROLLER_1_CONTROL          = $00A10008
MM_CONTROLLER_2_CONTROL          = $00A1000A
MM_EXPANSION_PORT_CONTROL        = $00A1000C

; Use this when we're cycling through the pads and we want to nn(An) access the CONTROL part
; when An points to the data register.
MM_CONTROLLER_DATA_TO_CONTROL_OFFSET = MM_CONTROLLER_1_CONTROL-MM_CONTROLLER_1_DATA
MM_CONTROLLER_DATA_SOURCE_STRIDE     = MM_CONTROLLER_2_DATA-MM_CONTROLLER_1_DATA

MM_CONTROLLER_1_SERIAL_TX        = $00A1000E
MM_CONTROLLER_1_SERIAL_RX        = $00A10010
MM_CONTROLLER_1_SERIAL_CONTROL   = $00A10012
MM_CONTROLLER_2_SERIAL_TX        = $00A10014
MM_CONTROLLER_2_SERIAL_RX        = $00A10016
MM_CONTROLLER_2_SERIAL_CONTROL   = $00A10018
MM_EXPANSION_PORT_SERIAL_TX      = $00A1001A
MM_EXPANSION_PORT_SERIAL_RX      = $00A1001C
MM_EXPANSION_PORT_SERIAL_CONTROL = $00A1001E

MM_MEMORY_MODE_REGISTER          = $00A11000

MM_Z80_MEMORY_SPACE              = $00A00000

MM_Z80_BUS_REQUEST               = $00A11100
MM_Z80_RESET                     = $00A11200

MM_TMSS_REGISTER                 = $00A14000 ; Longword sized.

MM_VDP_DATA                      = $00C00000
MM_VDP_CONTROL                   = $00C00004
MM_VDP_HV_COUNTER                = $00C00008

MM_SN76489_PSG                   = $00C00011 ; Write bytes only.

MM_YM2612_ADDRESS_P1             = $00A04000 ; Write bytes only.
MM_YM2612_DATA_P1                = $00A04001
MM_YM2612_ADDRESS_P2             = $00A04002
MM_YM2612_DATA_P2                = $00A04003

YM2612_STATUS_BYTE_BUSY_BIT      = 7

YM2612_22_LFO_FREQ               = $22
YM2612_24_TIMER_A_MSB            = $24
YM2612_25_TIMER_A_LSB            = $25
YM2612_26_TIMER_B_MSB            = $26
YM2612_27_CH3_MODE_TIMER_ENABLES = $27
YM2612_28_NOTE_ON_CONTROL        = $28
YM2612_2A_DAC_VALUE              = $2A
YM2612_2B_DAC_ENABLE             = $2B

RAM_BEGIN                        = $00FF0000
RAM_END                          = $00FFFFFF
RAM_SIZE_BYTES                   = $00010000
RAM_SIZE_WORDS                   = RAM_SIZE_BYTES/2
RAM_SIZE_LONGS                   = RAM_SIZE_BYTES/4

VRAM_SIZE_BYTES                  = $00010000
VRAM_SIZE_WORDS                  = VRAM_SIZE_BYTES/2
VRAM_SIZE_LONGS                  = VRAM_SIZE_BYTES/4

VSRAM_SIZE_WORDS                 = 40
VSRAM_SIZE_BYTES                 = VSRAM_SIZE_WORDS*2
VSRAM_SIZE_LONGS                 = VSRAM_SIZE_BYTES/4

CRAM_SIZE_WORDS                  = 16*4
CRAM_SIZE_BYTES                  = CRAM_SIZE_WORDS*2

PATTERN_SIZE_BYTES               = ((8*8*4)/8)
PATTERN_SIZE_WORDS               = PATTERN_SIZE_BYTES/2

; Constants with the write bit already set.
VDP_REGISTER_WRITE_COMMAND                                   = $8000
VDP_REGISTER_MODE_REGISTER_1                                 = VDP_REGISTER_WRITE_COMMAND|$0004 ; We're going to cheat and put the 1 that's expected here.
VDP_REGISTER_MODE_REGISTER_2                                 = VDP_REGISTER_WRITE_COMMAND|$0100
VDP_REGISTER_PLANE_A_NAME_TABLE_LOCATION                     = VDP_REGISTER_WRITE_COMMAND|$0200
VDP_REGISTER_WINDOW_NAME_TABLE_LOCATION                      = VDP_REGISTER_WRITE_COMMAND|$0300
VDP_REGISTER_PLANE_B_NAME_TABLE_LOCATION                     = VDP_REGISTER_WRITE_COMMAND|$0400
VDP_REGISTER_SPRITE_TABLE_LOCATION                           = VDP_REGISTER_WRITE_COMMAND|$0500
VDP_REGISTER_UNUSED_SPRITE_PATTERN_GENERATOR_BASE_ADDRESS    = VDP_REGISTER_WRITE_COMMAND|$0600
VDP_REGISTER_BACKGROUND_COLOUR                               = VDP_REGISTER_WRITE_COMMAND|$0700
VDP_REGISTER_UNUSED_08                                       = VDP_REGISTER_WRITE_COMMAND|$0800
VDP_REGISTER_UNUSED_09                                       = VDP_REGISTER_WRITE_COMMAND|$0900
VDP_REGISTER_HORIZONTAL_INTERRUPT_COUNTER                    = VDP_REGISTER_WRITE_COMMAND|$0A00
VDP_REGISTER_MODE_REGISTER_3                                 = VDP_REGISTER_WRITE_COMMAND|$0B00
VDP_REGISTER_MODE_REGISTER_4                                 = VDP_REGISTER_WRITE_COMMAND|$0C00
VDP_REGISTER_HORIZONTAL_SCROLL_DATA_LOCATION                 = VDP_REGISTER_WRITE_COMMAND|$0D00
VDP_REGISTER_UNUSED_NAMETABLE_PATTERN_GENERATOR_BASE_ADDRESS = VDP_REGISTER_WRITE_COMMAND|$0E00
VDP_REGISTER_AUTO_INCREMENT_VALUE                            = VDP_REGISTER_WRITE_COMMAND|$0F00
VDP_REGISTER_PLANE_SIZE                                      = VDP_REGISTER_WRITE_COMMAND|$1000
VDP_REGISTER_WINDOW_PLANE_HORIZONTAL_EXTENT                  = VDP_REGISTER_WRITE_COMMAND|$1100
VDP_REGISTER_WINDOW_PLANE_VERTICAL_EXTENT                    = VDP_REGISTER_WRITE_COMMAND|$1200
VDP_REGISTER_DMA_LENGTH_LOW_BYTE                             = VDP_REGISTER_WRITE_COMMAND|$1300
VDP_REGISTER_DMA_LENGTH_HIGH_BYTE                            = VDP_REGISTER_WRITE_COMMAND|$1400
VDP_REGISTER_DMA_SOURCE_ADDRESS_L                            = VDP_REGISTER_WRITE_COMMAND|$1500
VDP_REGISTER_DMA_SOURCE_ADDRESS_M                            = VDP_REGISTER_WRITE_COMMAND|$1600
VDP_REGISTER_DMA_SOURCE_ADDRESS_H                            = VDP_REGISTER_WRITE_COMMAND|$1700

VDP_REGISTER_1_EXTRA_VRAM_ENABLE               = %10000000 ; SEGA says always zero.
VDP_REGISTER_1_LEFTMOST_BLANK_ENABLE           = %00100000 ; SEGA says always zero.
VDP_REGISTER_1_HORIZONTAL_INTERRUPT_ENABLE     = %00010000
VDP_REGISTER_1_HV_COUNTER_LATCH_ENABLE         = %00000010
VDP_REGISTER_1_DISPLAY_ENABLE_AND_OVERLAY      = %00000001 ; SEGA says always zero.

VDP_REGISTER_2_TMS9918A_DISPLAY_ENABLE         = %10000000 ; SEGA says always zero.
VDP_REGISTER_2_DISPLAY_ENABLE                  = %01000000
VDP_REGISTER_2_VERTICAL_INTERRUPT_ENABLE       = %00100000
VDP_REGISTER_2_DMA_ENABLE                      = %00010000
VDP_REGISTER_2_PAL_ONLY_240_RESOLUTION_ENABLE  = %00001000
VDP_REGISTER_2_MEGA_DRIVE_VIDEO_MODE_ENABLE    = %00000100 ; SEGA says always one.

VDP_REGISTER_3_TH_LIGHTGUN_INTERRUPT_ENABLE    = %00001000
VDP_REGISTER_3_VERTICAL_SCROLL_2_CELLS         = %00000100
VDP_REGISTER_3_HORIZONTAL_SCROLL_COMPLETELY    = %00000000
VDP_REGISTER_3_HORIZONTAL_SCROLL_8_PIXELS      = %00000010
VDP_REGISTER_3_HORIZONTAL_SCROLL_1_PIXELS      = %00000011

VDP_REGISTER_4_320_PIXEL_WIDE_DISPLAY_ENABLE   = %10000001
VDP_REGISTER_4_VSYNC_IS_NOW_PIXEL_CLOCK_ENABLE = %01000000 ; SEGA says always zero.
VDP_REGISTER_4_HORIZONTAL_SYNC_FREEZE_ENABLE   = %00100000 ; SEGA says always zero.
VDP_REGISTER_4_EXTERNAL_PIXEL_BUS_ENABLE       = %00010000 ; SEGA says always zero.
VDP_REGISTER_4_SHADOW_HIGHLIGHT_MODE_ENABLE    = %00001000
VDP_REGISTER_4_INTERLACE_ENABLE                = %00000010
VDP_REGISTER_4_SONIC_2_DOUBLE_INTERLACE_ENABLE = %00000110

; These are the MSBs of the 16-bit short VDP command words we can send (if you want to access VSRAM you need a longword command!)
                           ;FEDCBA9876543210
                           ;10AAAAAAaaaaaaaa
VDP_WCOMMAND_VRAM_READ   = %0000000000000000
VDP_WCOMMAND_VRAM_WRITE  = %0100000000000000
VDP_WCOMMAND_CRAM_WRITE  = %1100000000000000

; Remember when you use one of these that you should really execute a final VRAM READ on $0000 to clear the topmost mode bits.
; Load a longword zero into (MM_VDP_CONTROL) that'll do it.
; Don't forget you need to shift your target address up by 16 bits to put it in the high word.
                           ;FEDCBA9876543210FEDBCA9876543210
                           ;10AAAAAAaaaaaaaaXXXXXXXX5432xxAA
VDP_LCOMMAND_VSRAM_READ  = %00000000000000000000000000010000
VDP_LCOMMAND_VSRAM_WRITE = %01000000000000000000000000010000

VDP_LCOMMAND_CRAM_READ   = %00000000000000000000000000100000

               ;FEDCBA9876543210
CONTROLLER_U = %0000000000000001
CONTROLLER_D = %0000000000000010
CONTROLLER_L = %0000000000000100
CONTROLLER_R = %0000000000001000
CONTROLLER_B = %0000000000010000
CONTROLLER_C = %0000000000100000
CONTROLLER_A = %0000000001000000
CONTROLLER_S = %0000000010000000
CONTROLLER_M = %0000000100000000
CONTROLLER_Z = %0000001000000000
CONTROLLER_Y = %0000010000000000
CONTROLLER_X = %0000100000000000
CONTROLLER_6 = %1000000000000000

; Use these for BTST if we've loaded a controller memory word into a register first.
CONTROLLER_U_BIT = 0
CONTROLLER_D_BIT = 1
CONTROLLER_L_BIT = 2
CONTROLLER_R_BIT = 3
CONTROLLER_B_BIT = 4
CONTROLLER_C_BIT = 5
CONTROLLER_A_BIT = 6
CONTROLLER_S_BIT = 7
CONTROLLER_M_BIT = 8
CONTROLLER_Z_BIT = 9
CONTROLLER_Y_BIT = 10
CONTROLLER_X_BIT = 11
CONTROLLER_6_BIT = 15 ; Down we if we are using a six button pad. :3

CONTROLLER_U_BIT_btst_l = 0 ; BTST only works on bytes when hitting a memory location for data source.
CONTROLLER_D_BIT_btst_l = 1 ; We need to target the low byte (+1) if we're BTSTing for this!
CONTROLLER_L_BIT_btst_l = 2
CONTROLLER_R_BIT_btst_l = 3
CONTROLLER_B_BIT_btst_l = 4
CONTROLLER_C_BIT_btst_l = 5
CONTROLLER_A_BIT_btst_l = 6
CONTROLLER_S_BIT_btst_l = 7
CONTROLLER_M_BIT_btst_h = 0 ; We need to target the high byte (+0) if we're BTSTing for this!
CONTROLLER_Z_BIT_btst_h = 1
CONTROLLER_Y_BIT_btst_h = 2
CONTROLLER_X_BIT_btst_h = 3
CONTROLLER_6_BIT_btst_h = 7

        setso   RAM_BEGIN

        macro trap_ram
        move.l  #$FFFFFFFF,(trap_ram_long)
        endm

trap_ram_long                            so.l  1

pad_1_curr                               so.w  1
pad_1_prev                               so.w  1

pad_1_pressed                            so.w  1                    ; Pressed  =  curr & !prev
pad_1_held                               so.w  1                    ; Held     =  curr &  prev
pad_1_released                           so.w  1                    ; Released = !curr &  prev
pad_1_idle                               so.w  1                    ; Idle     = !curr & !prev

pad_2_curr                               so.w  1
pad_2_prev                               so.w  1

pad_2_pressed                            so.w  1                    ; Pressed  =  curr & !prev
pad_2_held                               so.w  1                    ; Held     =  curr &  prev
pad_2_released                           so.w  1                    ; Released = !curr &  prev
pad_2_idle                               so.w  1                    ; Idle     = !curr & !prev

PAD_STATUS_STRUCT_STRIDE = pad_2_curr-pad_1_curr

vblank_flag                              so.w  1                    ; It's a word that occurs after the pad stuff, BUT we're only using the low byte of it for alignment's sake.

vblank_flag_low_byte = vblank_flag+1

cursor_x                                 so.b  1
cursor_y                                 so.b  1

operator_values                          so.b  12*4 ; There are twelve values per operator line, and four operators. No channel 3 special mode here, I'm afraid.

feedback_value                           so.b  1
algorithm_value                          so.b  1
ams_value                                so.b  1
fms_value                                so.b  1

lfoen_value                              so.b  1
lfo_value                                so.b  1

note_value                               so.b  1

const_value                              so.b  1

lfoen_value_invalidated                  so.b  1 ; Zero if the FM space is set up with the most recent value.

        macro interrupts_disable
        move    #%0010011100000000,SR            ; Disable interrupts: set supervisor bit and set mask to 7 to disable all interrupts.
        endm

        macro interrupts_enable
        move    #%0010001100000000,SR            ; Enable interrupts: set supervisor bit and set mask to 3 to disable unused interrupts. (Allowing v and hblank.)
        endm

        macro z80_bus_request_engage
        move.w  #$0100,(MM_Z80_BUS_REQUEST)
        endm

        macro z80_wait_bus_available
\@      btst    #0,(MM_Z80_BUS_REQUEST)
        bne     \@
        endm

        macro z80_bus_request_disengage
        move.w  #$0000,(MM_Z80_BUS_REQUEST)
        endm

        macro z80_reset_engage
        move.w  #$0000,(MM_Z80_RESET)
        endm

        macro z80_reset_disengage
        move.w  #$0100,(MM_Z80_RESET)
        endm

; Pass if vblank has already happened. Otherwise stop and wait for vblank.
        macro vblank_wait
\@again btst    #0,(vblank_flag_low_byte)        ; STOP is probably better practice: it frees up the bus for other things, but what if an interrupt happens RIGHT HERE... we'll miss an entire frame until the next VBlank unsticks the STOP.
        bne     \@out
        stop    #%0010001100000000               ; Wait for interrupts: set supervisor bit and set mask to 3 to disable unused interrupts. (Allowing v and hblank.)
        jmp     \@again
\@out   move.b  #0,(vblank_flag_low_byte)
        endm

; First argument is data register to use for loop counter, second argument is address register to use for memory source, third argument is palette line to target.
; Assumes VRAM increment of 2.
        macro palette_write
        move.w  #(VDP_WCOMMAND_CRAM_WRITE)|(32*(\3)),(MM_VDP_CONTROL)
        move.w  #15,\1
\@next  move.w  (\2)+,(MM_VDP_DATA)
        dbf     \1,\@next
        endm

        macro YM2612_wait
\@again btst    #YM2612_STATUS_BYTE_BUSY_BIT,(MM_YM2612_ADDRESS_P1)
        bne     \@again
        endm

; Move A copies of B into C ascending using D as the loop counter.
        macro DBF_memory_fill
        move.w  #(\1-1),\4
\@next  move.b  #\2,(\3)+
        dbf     \4,\@next
        endm


        org $200
main:
initialise_megadrive:
        interrupts_disable
        jsr     tmss_satisfy_tmss
        interrupts_enable
        jsr     vdp_initialise_registers
        vblank_wait
        jsr     vdp_clear_all_cram

        jsr     clear_all_ram
        jsr     z80_initialise

        vblank_wait
        jsr     vdp_clear_all_vram               ; Clears the sprite table too, which is held in VRAM of course.
        jsr     vdp_clear_all_vsram              ; Clears the VSRAM.

        ; Write the longword zero into MM_VDP_CONTROL to reset the high bits of VDP write address.
        move.l  #0,(MM_VDP_CONTROL)

        lea     (palette_0),a0
        palette_write d0,a0,0
        lea     (palette_1),a0
        palette_write d0,a0,1
        lea     (palette_2),a0
        palette_write d0,a0,2
        lea     (palette_3),a0
        palette_write d0,a0,3

        jsr     instrument_patch_values_initialise     ; Initialise the values behind the interface I'm designing.

        vblank_wait

        ; Tile $01B4 is the space character. It's the first character available in VRAM after my Plane A Plane B Window and Sprite tables.
        ; It's at $3680.
        
        ; Write the longword zero into MM_VDP_CONTROL to reset the high bits of VDP write address.
        move.l  #0,(MM_VDP_CONTROL)

        lea     (MM_VDP_DATA),a6
        vblank_wait
        ; Copy my pattern into VRAM at $36A0. ($3680 is the first tile, but it's a SPACE character!)
        move.w  #(VDP_WCOMMAND_VRAM_WRITE|$36A0),(MM_VDP_CONTROL)
        move.w  #((PATTERN_DATA_SIZE_BYTES/2)-1),d0
        lea     pattern_data,a0
l_n     move.w  (a0)+,d1
        ror.b   #4,d1        ; Make ABCD into BADC. My greenfont binary is designed for another graphics tile layout (reused from an SMS project), so endure the swizzle here!
        ror.w   #8,d1
        ror.b   #4,d1
        ror.w   #8,d1
        move.w  d1,(a6)
        dbf     d0,l_n

        vblank_wait
        move.w  #((BACKGROUND_PATTERN_DATA_SIZE_BYTES/2)-1),d0
        lea     background_pattern_data,a0
l_nb    move.w  (a0)+,d1
        ror.b   #4,d1        ; Make ABCD into BADC.
        ror.w   #8,d1
        ror.b   #4,d1
        ror.w   #8,d1
        move.w  d1,(a6)
        dbf     d0,l_nb

        vblank_wait
        ; Fill the PLANE A plane with space tile.
        move.w  #(VDP_WCOMMAND_VRAM_WRITE|$0000),(MM_VDP_CONTROL)
        move.w  #(64*32)-1,d0
        move.w  #$01B4,d1
l_nt    move.w  d1,(a6)
        dbf     d0,l_nt

        vblank_wait
        ; Fill the PLANE B plane with the background graphics.
        move.w  #(VDP_WCOMMAND_VRAM_WRITE|$2000),d4  ; We need to submit multiple VDP address targeting commands as we descend the screen.
        lea     background_pattern_map_data,a0
        move.w  #$41B5+80,d2                         ; Use end of text tile as zero base for the tiles read from the map.
        move.w  #24-1,d0                             ; Only 24 rows of tiles.
lbt_nty move.w  #40-1,d1
        move.w  d4,(MM_VDP_CONTROL)
lbt_ntx move.w  d2,d3                                ; Load default tile tegel basis word value into d3.
        add.w   (a0)+,d3                             ; Add tile number read from map.
        move.w  d3,(a6)                              ; Load final tile tegel into VDP.
        dbf     d1,lbt_ntx
        add.w   #128,d4
        dbf     d0,lbt_nty
        ; The exporter messed up, but the rest of the tiles are contiguous anyway so hooray.
        move.w  #4-1,d0                              ; Final 4 rows.
lbg_nty move.w  #40-1,d1
        move.w  d4,(MM_VDP_CONTROL)
lbg_ntx add.w   #1,d3                                ; Add constant.
        move.w  d3,(a6)                              ; Load final tile tegel into VDP.
        dbf     d1,lbg_ntx
        add.w   #128,d4
        dbf     d0,lbg_nty

loop:
        vblank_wait

        jsr     instrument_patch_values_draw_interface

        jsr     controllers_read
        jsr     controllers_derive

        jsr     instrument_patch_values_interface_handle_controls

        ; Constantly update FM space if CONST is active.
        cmp.b   #0,(const_value)
        beq     const_is_not_active
        jsr     instrument_patch_values_load_into_YM2612
const_is_not_active:

        jmp     loop

; Subroutines.

vblank:
        move.b  #1,(vblank_flag_low_byte)
        rte

hblank:
unhandled_exception:
        rte

tmss_satisfy_tmss:
        move.b  (MM_VERSION_REGISTER+1),d0       ; Load the low byte from the version register.
        and.b   #$0F,d0
        beq     tmss_satisfy_tmss_unnecessary
        move.l  #"SEGA",(MM_TMSS_REGISTER)       ; Satisy TMSS on version != zero consoles by writing SEGA longword to its register.
tmss_satisfy_tmss_unnecessary:                   ; Branch here if we're on a version zero console that does not require TMSS compliance.
        rts

; We want all the ram cleared.
clear_all_ram:
        lea     RAM_BEGIN,a0
        move.w  #(RAM_SIZE_LONGS-101),d0         ; We don't want to smash the call stack, you fool. Assume that this routine was called while the stack < 100 longs.
        clr.w   d1
clear_all_ram_next_long:
        move.w  d1,(a0)+
        dbf     d0,clear_all_ram_next_long
        rts

; Put the VDP into a good state. VBlank interrupts enabled. HBlank disabled. 320x224 resolution.
vdp_initialise_registers:
        lea     (MM_VDP_CONTROL),a6
        move.w  #(VDP_REGISTER_MODE_REGISTER_1|$00),(a6)
        move.w  #(VDP_REGISTER_MODE_REGISTER_2|VDP_REGISTER_2_VERTICAL_INTERRUPT_ENABLE|VDP_REGISTER_2_DISPLAY_ENABLE|VDP_REGISTER_2_MEGA_DRIVE_VIDEO_MODE_ENABLE),(a6)
        move.w  #(VDP_REGISTER_MODE_REGISTER_3|$00),(a6)
        move.w  #(VDP_REGISTER_MODE_REGISTER_4|VDP_REGISTER_4_320_PIXEL_WIDE_DISPLAY_ENABLE),(a6)

        move.w  #(VDP_REGISTER_AUTO_INCREMENT_VALUE|$02),(a6) ; We're going to assume this all over the place. If you change it away, CHANGE IT BACK.

        move.w  #(VDP_REGISTER_PLANE_A_NAME_TABLE_LOCATION|%00000000),(a6)            ; NT A = $0000-$1000
        move.w  #(VDP_REGISTER_WINDOW_NAME_TABLE_LOCATION|%00000100),(a6)             ; W B  = $1000-$2000
        move.w  #(VDP_REGISTER_PLANE_B_NAME_TABLE_LOCATION|%00000001),(a6)            ; NT B = $2000-$3000
        move.w  #(VDP_REGISTER_HORIZONTAL_SCROLL_DATA_LOCATION|%00001100),(a6)        ; HS   = $3000-$3400
        move.w  #(VDP_REGISTER_SPRITE_TABLE_LOCATION|%00011010),(a6)                  ; ST   = $3400-$3680

        move.w  #(VDP_REGISTER_BACKGROUND_COLOUR|$00),(a6)
        move.w  #(VDP_REGISTER_PLANE_SIZE|$01),(a6)                                   ; A and B are both 64x 32y.

        move.w  #(VDP_REGISTER_WINDOW_PLANE_HORIZONTAL_EXTENT|$00),(a6)               ; Full zero prevents window plane display.
        move.w  #(VDP_REGISTER_WINDOW_PLANE_VERTICAL_EXTENT|$00),(a6)

        move.w  #(VDP_REGISTER_UNUSED_SPRITE_PATTERN_GENERATOR_BASE_ADDRESS|$00),(a6)
        move.w  #(VDP_REGISTER_UNUSED_08|$00),(a6)
        move.w  #(VDP_REGISTER_UNUSED_09|$00),(a6)
        move.w  #(VDP_REGISTER_UNUSED_NAMETABLE_PATTERN_GENERATOR_BASE_ADDRESS|$00),(a6)
        rts

; Clear the entire contents of the ordinary VRAM. (As opposed to the CRAM or VSRAM.)
vdp_clear_all_vram:
        ; Write the longword zero into MM_VDP_CONTROL to reset the high bits of VDP write address.
        move.l  #0,(MM_VDP_CONTROL)
        ; Set up writing VRAM from VRAM start, incrementing by words.
        move.w  #(VDP_WCOMMAND_VRAM_WRITE),(MM_VDP_CONTROL)
        move.w  #(VRAM_SIZE_WORDS-1),d0
        move.w  #0,d1
vdp_clear_all_vram_next_word:
        move.w  d1,(MM_VDP_DATA)
        dbf     d0,vdp_clear_all_vram_next_word
        rts

; Clear the entire contents of the VSRAM.
vdp_clear_all_vsram:
        ; Set up writing VSRAM from VSRAM start, incrementing by words.
        move.l  #(VDP_LCOMMAND_VSRAM_WRITE),(MM_VDP_CONTROL)
        move.w  #(VSRAM_SIZE_WORDS-1),d0
        move.w  #0,d1
vdp_clear_all_vsram_next_word:
        move.w  d1,(MM_VDP_DATA)
        dbf     d0,vdp_clear_all_vsram_next_word
        rts

; Clear the CRAM to black for all four palettes.
vdp_clear_all_cram:
        ; Write the longword zero into MM_VDP_CONTROL to reset the high bits of VDP write address.
        move.l  #0,(MM_VDP_CONTROL)
        ; Set up writing CRAM from CRAM start, incrementing by words.
        move.w  #(VDP_WCOMMAND_CRAM_WRITE),(MM_VDP_CONTROL)
        move.w  #(CRAM_SIZE_WORDS-1),d0
        move.w  #0,d1
vdp_clear_all_cram_next_word:
        move.w  d1,(MM_VDP_DATA)
        dbf     d0,vdp_clear_all_cram_next_word
        rts

        align   2

palette_0:
        dc.w    $0000,$0242,$0282,$04E4,$0e00,$0e60,$0ea2,$0eee,$0000,$0224,$0228,$044E,$0000,$0244,$0288,$04EE
palette_1:
        dc.w    $0e00,$0e60,$0ea2,$0eee,$0444,$0464,$0666,$0868,$0888,$08A8,$0AAA,$0CAC,$0CCC,$0CEC,$0EEE,$0EEE
palette_2:
        dc.w    $0000,$0200,$0222,$0422,$0020,$0242,$0444,$0666,$0888,$06E6,$0862,$0A96,$0228,$022A,$0EEE,$0EEE
palette_3:
        dc.w    $0e00,$0e60,$0ea2,$0eee,$0e22,$0e22,$0e44,$0e46,$0e66,$0e66,$0e8A,$0e8A,$0eAA,$0eAA,$0EAA,$0EEE

PATTERN_DATA_SIZE_BYTES = pattern_data_end-pattern_data

pattern_data:
        incbin  "greenfont.img.bin"
pattern_data_end:

BACKGROUND_PATTERN_DATA_SIZE_BYTES = background_pattern_data_end-background_pattern_data

        align   2

background_pattern_data:
        incbin  "FMedit_back_16color_4bit2.img.bin"
background_pattern_data_end:

        align   2

background_pattern_map_data:
        incbin  "FMedit_back_16color_4bit2.map.bin"
background_pattern_map_data_end:

        align   2

; Make the z80 inert for the time being.
; According to the sega documentation, the correct sequence for loading the Z80 program is:
;    (1) BUS REQ ON
;    (2) BUS RESET OFF
;    (3) 68K copies program into Z-80 S-RAM
;    (4) BUS RESET ON
;    (5) BUS REQ OFF
;    (6) BUS RESET OFF
z80_initialise:
        interrupts_disable
        z80_bus_request_engage
        z80_reset_disengage
        z80_wait_bus_available

        lea     MM_Z80_MEMORY_SPACE,a0

        move.b  #$C3,(a0)+                         ; Put a [jp $0000] at $0000.
        move.b  #$00,(a0)+
        move.b  #$00,(a0)

        z80_reset_engage
        z80_bus_request_disengage
        z80_reset_disengage
        interrupts_enable
        rts

; Intialise the values for the FM patch interface.
instrument_patch_values_initialise:
        move.b  #0,d0
        move.b  d0,(cursor_x)
        move.b  d0,(cursor_y)
        move.b  d0,(algorithm_value)
        move.b  d0,(feedback_value)
        move.b  d0,(ams_value)
        move.b  d0,(fms_value)
        move.b  #0,(lfoen_value)
        move.b  #0,(lfo_value)
        move.b  #12*3,(note_value)
        move.b  #0,(const_value)

        lea     operator_values,a0

        move.b  #$FF,(a0)+
        move.b  #$00,(a0)+
        move.b  #127,(a0)+
        move.b  #31,(a0)+
        move.b  #7,(a0)+
        move.b  #15,(a0)+
        move.b  #5,(a0)+
        move.b  #15,(a0)+
        move.b  #0,(a0)+
        move.b  #1,(a0)+
        move.b  #0,(a0)+
        move.b  #$00,(a0)+

        move.b  #$FF,(a0)+
        move.b  #$00,(a0)+
        move.b  #127,(a0)+
        move.b  #31,(a0)+
        move.b  #7,(a0)+
        move.b  #15,(a0)+
        move.b  #5,(a0)+
        move.b  #15,(a0)+
        move.b  #0,(a0)+
        move.b  #1,(a0)+
        move.b  #0,(a0)+
        move.b  #$00,(a0)+

        move.b  #$FF,(a0)+
        move.b  #$00,(a0)+
        move.b  #127,(a0)+
        move.b  #31,(a0)+
        move.b  #7,(a0)+
        move.b  #15,(a0)+
        move.b  #5,(a0)+
        move.b  #15,(a0)+
        move.b  #0,(a0)+
        move.b  #1,(a0)+
        move.b  #0,(a0)+
        move.b  #$00,(a0)+

        move.b  #$FF,(a0)+
        move.b  #$00,(a0)+
        move.b  #$0,(a0)+
        move.b  #31,(a0)+
        move.b  #7,(a0)+
        move.b  #15,(a0)+
        move.b  #5,(a0)+
        move.b  #15,(a0)+
        move.b  #0,(a0)+
        move.b  #1,(a0)+
        move.b  #0,(a0)+
        move.b  #$00,(a0)+
        rts

; These are 2^(1/12) ratio between semitones.
; I originally used Maxim's table from World of Stuff, but that seemed to be tuned a few tones out, so I'm
; using a table I devised myself with C based at zero. Spent ages tuning this I did. ;P
instrument_patch_values_frequency_constants: ; No spaces in constants? Thanks, vasm.
        dc.b ((0<<3)|(644>>8))
        dc.b ((644&$FF))

        dc.b ((0<<3)|(682>>8))
        dc.b ((682&$FF))

        dc.b ((0<<3)|(723>>8))
        dc.b ((723&$FF))

        dc.b ((0<<3)|(766>>8))
        dc.b ((766&$FF))

        dc.b ((0<<3)|(811>>8))
        dc.b ((811&$FF))

        dc.b ((0<<3)|(860>>8))
        dc.b ((860&$FF))

        dc.b ((0<<3)|(911>>8))
        dc.b ((911&$FF))

        dc.b ((0<<3)|(965>>8))
        dc.b ((965&$FF))

        dc.b ((0<<3)|(1022>>8))
        dc.b ((1022&$FF))

        dc.b ((0<<3)|(1083>>8))
        dc.b ((1083&$FF))

        dc.b ((0<<3)|(1147>>8))
        dc.b ((1147&$FF))

        dc.b ((0<<3)|(1216>>8))
        dc.b ((1216&$FF))

YM2612_send_note_on:
        ; Assert the Z80 bus to load values into the YM2612.
        interrupts_disable
        z80_bus_request_engage
        z80_wait_bus_available

        ; Calculate the final operator NOTE ON command into d0
        move.b  #%00000000,d0                                         ; Clear d0, use it to store active operator line bits.
        move.b  #%00010000,d1                                         ; Operator note on poisitons begin here and shift to the left for each operator.
        lea     operator_values,a0                                    ; Read the operator values from the operator_values memory.
YM2612_send_note_on_construct_operator_note_on_next_operator:
        move.b  d1,d2                                                 ; Copy the operator bitmask.
        and.b   (a0),d2                                               ; AND so that the operator bitmask is present if we're enabling this channel.
        or.b    d2,d0                                                 ; OR into d0 to combine all the active bitmasks for enabled channels.
        lea     12(a0),a0                                             ; Advance to the next line of operator values.
        lsl.b   #1,d1                                                 ; Shift the bitmask to the next operator slot.
        bne     YM2612_send_note_on_construct_operator_note_on_next_operator ; Stop when we shift that 1 all the way out of d1.
                                                                      ; d0 contains enabled operators

        YM2612_wait
        move.b  #YM2612_28_NOTE_ON_CONTROL,(MM_YM2612_ADDRESS_P1)                                   ; Target note on control.
        YM2612_wait
        move.b  d0,(MM_YM2612_DATA_P1)                                                              ; Write the NOTE ON.

        z80_bus_request_disengage
        interrupts_enable

        rts

YM2612_send_note_off:
        ; Assert the Z80 bus to load values into the YM2612.
        interrupts_disable
        z80_bus_request_engage
        z80_wait_bus_available

        YM2612_wait
        move.b  #YM2612_28_NOTE_ON_CONTROL,(MM_YM2612_ADDRESS_P1)                                   ; Target note on control.
        YM2612_wait
        move.b  #0,(MM_YM2612_DATA_P1)                                                              ; Write the NOTE OFF.

        z80_bus_request_disengage
        interrupts_enable
        rts

; Convert the values from the FM patch interface into the correct register
; values and load these into the YM2612 for Channel 0.
instrument_patch_values_load_into_YM2612:
        ; Calculate them backwards and push them onto the stack so we can then read them forwards!

        ; a6 will be our 'stack pointer' for this routine. We can't use a7 as it must be word aligned at all times.
        move.l  a7,a6

        ; Allocate 34 bytes on the stack.
        lea     -34(a7),a7

        ; Construct the FEEDBACK ALGORITHM line.
        move.b  (feedback_value),d0
        lsl.b   #3,d0
        or.b    (algorithm_value),d0
        move.b  d0,-(a6)

        ; Construct the LR AMS FMS line.
        move.b  (ams_value),d0
        lsl.b   #4,d0
        or.b    (fms_value),d0
        or.b    #%11000000,d0
        move.b  d0,-(a6)

        ; Construct the LFOEN LFO line.
        move.b  (lfoen_value),d0
        and.b   #%00001000,d0
        or.b    (lfo_value),d0
        move.b  d0,-(a6)

        ; Identify the frequency values to use for the currently selected note.
        move.b  #0,d1                                                                ; Use d1 to store octave number.
        move.l  #0,d2                                                                ; Clear uppermost bits of d2.
        move.b  (note_value),d2
instrument_patch_values_load_into_YM2612_repeat_subtraction:                         ; Divide note_value by 12 into d1.
        cmp.b   #12,d2                                                               ; Repeatedly subtract 12 from d2 to get octave into d1.
        blt     instrument_patch_values_load_into_YM2612_divide_note_value_loop_ends
        sub.b   #12,d2
        add.b   #1,d1
        jmp     instrument_patch_values_load_into_YM2612_repeat_subtraction
instrument_patch_values_load_into_YM2612_divide_note_value_loop_ends:                ; d1 contains note_value / 12. d2 contains note_value % 12.
        ; Convert note + octave into LSB, MSB|BLOCK
        trap_ram
        lsl.b   #3,d1                                                                ; Convert octave into BLOCK value.
        lsl.b   #1,d2                                                                ; d2 is offset into frequency values array.
        move.l  d2,a0                                                                ; Construct instrument_patch_values_frequency_constants[note] (as word read)
        add.l   #instrument_patch_values_frequency_constants,a0                      ; a0 points to MSB part of the correct frequency value.
        or.b    (a0)+,d1                                                             ; d1 contains final MSB value with BLOCK.
        move.b  (a0),-(a6)                                                           ; Push the LSB first
        move.b  d1,-(a6)                                                             ; followed by the MSB value with BLOCK.

        lea     -28(a6),a6                                                           ; Make an area of 28 bytes for operator values.
        ; a6 now points to the start (first byte within) of the operator values area. (because it is a full descending stack)
        move.l  a6,a5                                                                ; Use a5 to monkey around in this area.
        ; We're going to store all the DT1 MUL values one after the other. These are located in FM space all in a row 4 bytes apart.
        ; Because our operator lines in the interface are continuous, a5 will be set to 0 then 1 then 2 then 3 as we go through each
        ; operator in order to interleave the operators in a5-space.

        lea     operator_values,a0                                                   ; Point to the first operator line.
        move.w  #3,d0                                                                ; Four operator lines.
instrument_patch_values_load_into_YM2612_construct_operator_values_next_line:
        move.b  10(a0),d1                                                            ; Load DT1 part from operator_values
        lsl.b   #4,d1                                                                ; Shift DT1 part into position.
        or.b    9(a0),d1                                                             ; OR the MUL part.
        move.b  d1,0(a5)                                                             ; Store the final DT1 MUL line for the current operator.

        move.b  2(a0),4(a5)                                                          ; Store the final TL line for the current operator.

        move.b  8(a0),d1                                                             ; Load RS part from operator_values
        lsl.b   #6,d1                                                                ; Shift RS part into position.
        or.b    3(a0),d1                                                             ; OR the AR part.
        move.b  d1,8(a5)                                                             ; Store the final RS AR line for the current operator.

        move.b  1(a0),d1                                                             ; Load AM part from operator_values
        or.b    4(a0),d1                                                             ; OR the D1R part.
        move.b  d1,12(a5)                                                            ; Store the final AM D1R line for the current operator.

        move.b  6(a0),16(a5)                                                         ; Store the final D2R line for the current operator.

        move.b  5(a0),d1                                                             ; Load D1L part from operator_values
        lsl.b   #4,d1                                                                ; Shift D1L part into position.
        or.b    7(a0),d1                                                             ; OR the RR part.
        move.b  d1,20(a5)                                                            ; Store the final D1L RR line for the current operator.

        move.b  11(a0),24(a5)                                                        ; Store the final SSGEG line for the current operator.

        lea     1(a5),a5                                                             ; Shimmy a5 to address the values for the next operator line.
        lea     12(a0),a0                                                            ; Advance to the next operator line.
        dbf     d0,instrument_patch_values_load_into_YM2612_construct_operator_values_next_line


        ; This this point a6 will point to an array of bytes on the stack containing values we want to insert into FM space
        ; 4xDT1MUL, 4xTL, 4xRSAR, 4xAMD1R, 4xD2R, 4xD1LRR, 4xSSGEG, BLOCKMSB, LSB, LFOEN LFO, LS AMS FMS, FEEDBACK ALGORITHM
        
        ; Now I'm going to switch the values for operator lines 3 and 2 in the command packet.
        ; This is because they're listed as 13241324, not 12341234.
        ; Thanks, Yamaha.
        move.w  #6,d0                                                                ; Seven operator line register values to touch.
        lea     1(a6),a5                                                             ; a5 points to the DT1 MUL value for op line 2 (BEFORE SWITCHING)
instrument_patch_values_load_into_YM2612_switch_operator_values_next_value
        move.b  (a5)+,d1                                                             ; Take value from slot 2
        move.b  (a5),-1(a5)                                                          ; Put value from slot 3 into slot 2
        move.b  d1,(a5)                                                              ; Put value from slot 2 into slot 3.
        lea     3(a5),a5                                                             ; Advance to next register category.
        dbf     d0,instrument_patch_values_load_into_YM2612_switch_operator_values_next_value

        ; Assert the Z80 bus to load values into the YM2612.
        interrupts_disable
        z80_bus_request_engage
        z80_wait_bus_available

        ; Load the values.
        lea     MM_YM2612_ADDRESS_P1,a0
        lea     MM_YM2612_DATA_P1,a1

        ; Write 28 values to the registers between $30 and <$A0, for FM channel zero these are all spaced by four bytes.
        move.l  #0,d0                                                                  ; Clear the uppermost bytes of d0.
        move.b  #$30,d0                                                                ; Target the DT1 MUL line for OP1.
        move.w  #28-1,d1                                                               ; Writing all seven parameters for four OPs.
instrument_patch_values_load_into_YM2612_submit_next_operator_value:
        YM2612_wait
        move.b  d0,(a0)                                                                ; Target the appropriate OP register value.
        add.b   #4,d0                                                                  ; Advance to next OP register value in FM registers.
        YM2612_wait
        move.b  (a6)+,(a1)                                                             ; Submit and advance to next OP register value.
        dbf     d1,instrument_patch_values_load_into_YM2612_submit_next_operator_value ; Decrement remaining OPs to write counter.

        YM2612_wait
        move.b  #$A4,(a0)                                                              ; Target BLOCK MSB.
        YM2612_wait
        move.b  (a6)+,(a1)                                                             ; Write the BLOCK MSB

        YM2612_wait
        move.b  #$A0,(a0)                                                              ; Target LSB.
        YM2612_wait
        move.b  (a6)+,(a1)                                                             ; Write the LSB

        ; Only change the LFO value if its invalidated. Remember how the PSG white noise generator resets when you change its parameters on SMS!
        move.b  (a6)+,d0                                                               ; Retrieve LFOEN LFO even if we're not writing it.
        cmp.b   #0,(lfoen_value_invalidated)
        beq     instrument_patch_values_load_into_YM2612_LFOEN_not_invalidated       
        move.b  #0,(lfoen_value_invalidated)
        YM2612_wait
        move.b  #$22,(a0)                                                              ; Target LFOEN LFO.
        YM2612_wait
        move.b  d0,(a1)                                                                ; Write the LFOEN LFO
instrument_patch_values_load_into_YM2612_LFOEN_not_invalidated:

        YM2612_wait
        move.b  #$B4,(a0)                                                              ; Target LR AMS FMS.
        YM2612_wait
        move.b  (a6)+,(a1)                                                             ; Write the LR AMS FMS

        YM2612_wait
        move.b  #$B0,(a0)                                                              ; Target FEEDBACK ALGORITHM.
        YM2612_wait
        move.b  (a6)+,(a1)                                                             ; Write the FEEDBACK ALGORITHM


        z80_bus_request_disengage
        interrupts_enable

        ; Release the 34 bytes back to the stack.
        lea     34(a7),a7
        rts

; d0 is x, d1 is y, d2 is palette line (x and y are words) a0 is null terminated string.
vdp_draw_string:
        ; Write the longword zero into MM_VDP_CONTROL to reset the high bits of VDP write address.
        move.l  #0,(MM_VDP_CONTROL)

        movem.l vdp_draw_string_regs,-(a7)
        lsl.w   #6,d1                                                      ; Y *= 64.
        or.w    d1,d0                                                      ; d0 is total tile number.
        lsl.w   #1,d0                                                      ; d0 is final tile address into map.
        or.w    #(VDP_WCOMMAND_VRAM_WRITE|$0000),d0                        ; Write into PLANE A.
        move.w  d0,(MM_VDP_CONTROL)                                        ; Target tile X Y in PLANE A.

        ; Construct the palette line contribution to final value in d2.
        and.w   #3,d2                                                      ; Remove spurious stuff, only take two lowestmost bits.
        ror.w   #3,d2                                                      ; Roll the palette byte into bit 13.
        add.w   #$01B4-'0'+1,d2                                            ; ASCII character is offset from first character from space tile (zero is first printable)

        lea     (MM_VDP_DATA),a6
vdp_draw_string_next_character:
        move.w  #0,d0
        move.b  (a0)+,d0                                                   ; Retrieve character.
        beq     vdp_draw_string_return
        add.w   d2,d0                                                      ; Convert letter index into final VDP tegel word.
        move.w  d0,(a6)
        jmp     vdp_draw_string_next_character
vdp_draw_string_return:
        movem.l (a7)+,vdp_draw_string_regs
        rts
vdp_draw_string_regs reg d0/d1/d2/d6/a0/a6

; a0 is address to start placing
; d0 is value
place_right_aligned_number:
        movem.l place_right_aligned_number_regs,-(a7)

        lea     -10(a7),a7

        move.l  a0,a1
        move.l  a7,a0
        jsr     BCDbs_CreateSequence

        lea     BCDBS_BYTE_SEQUENCE_LENGTH(a0),a0
        lea     1(a1),a1
        sub.b   #1,d7
place_right_aligned_number_next_number:
        move.b  -(a0),d0
        add.b   #'0',d0
        move.b  d0,-(a1)
        dbf     d7,place_right_aligned_number_next_number

        lea     10(a7),a7

        movem.l (a7)+,place_right_aligned_number_regs
        rts
place_right_aligned_number_regs reg d0-d7/a0-a6

instrument_patch_values_draw_interface:
        ; Draw the captions along the top of the screen.
        move.w  #0,d0
        move.w  #2,d1
        move.b  #1,d2
        lea     (instrument_patch_values_interface_parameter_caption),a0
        jsr     vdp_draw_string

        ; Construct the text strings for each operator line.
        lea     -44(a7),a7                                                                            ; Get 44 bytes to construct a string into.

        lea     (operator_values),a1
        move.w  #3,d7
instrument_patch_values_draw_interface_draw_operator_line_string_next_line:
        ; Construct the string into a7 (using a0).
        move.l  a7,a0
        DBF_memory_fill 42,' ',a0,d1                                                                  ; Write 42 copies of ' ' into a0 using d1.
        move.b  #0,(a0)                                                                               ; Write a terminating zero.

        move.l  a7,a0

        move.l  #0,d0                                                                                 ; Make upper three bytes of d0 zero.
        move.b  (a1)+,d0                                                                              ; Test the enable for this operator line.
        beq     instrument_patch_values_draw_interface_draw_operator_line_enable_is_blank
        move.b  #'\\',0(a0)                                                                            ; X if enabled.
instrument_patch_values_draw_interface_draw_operator_line_enable_is_blank:

        move.b  (a1)+,d0                                                                              ; Test the am enable for this operator line.
        beq     instrument_patch_values_draw_interface_draw_operator_line_am_enable_is_blank
        move.b  #'\\',2(a0)
instrument_patch_values_draw_interface_draw_operator_line_am_enable_is_blank:

        move.b  (a1)+,d0                                                                              ; d0 is TL value as longword.
        lea     6(a7),a0
        jsr     place_right_aligned_number                                                            ; Place the right aligned number at cell 8 in string.

        move.b  (a1)+,d0                                                                              ; d0 is AR value as longword.
        lea     9(a7),a0
        jsr     place_right_aligned_number                                                            ; Place the right aligned number at cell 8 in string.

        move.b  (a1)+,d0                                                                              ; d0 is D1R value as longword.
        lea     13(a7),a0
        jsr     place_right_aligned_number                                                            ; Place the right aligned number at cell 8 in string.

        move.b  (a1)+,d0                                                                              ; d0 is D1L value as longword.
        lea     17(a7),a0
        jsr     place_right_aligned_number                                                            ; Place the right aligned number at cell 8 in string.

        move.b  (a1)+,d0                                                                              ; d0 is D2R value as longword.
        lea     21(a7),a0
        jsr     place_right_aligned_number                                                            ; Place the right aligned number at cell 8 in string.

        move.b  (a1)+,d0                                                                              ; d0 is RR value as longword.
        lea     24(a7),a0
        jsr     place_right_aligned_number                                                            ; Place the right aligned number at cell 8 in string.

        move.b  (a1)+,d0                                                                              ; d0 is RS value as longword.
        lea     27(a7),a0
        jsr     place_right_aligned_number                                                            ; Place the right aligned number at cell 8 in string.

        move.b  (a1)+,d0                                                                              ; d0 is MUL value as longword.
        lea     31(a7),a0
        jsr     place_right_aligned_number                                                            ; Place the right aligned number at cell 8 in string.

        move.b  (a1)+,d0                                                                              ; d0 is DT1 value as longword.
        lea     35(a7),a0
        jsr     place_right_aligned_number                                                            ; Place the right aligned number at cell 8 in string.

        move.b  (a1)+,d0                                                                              ; d0 is SSGEG value as longword.
        lea     39(a7),a0
        jsr     place_right_aligned_number                                                            ; Place the right aligned number at cell 8 in string.

        move.w  #0,d0                                                                                 ; Construct coordinates for writing the text string.
        move.w  #10,d1
        move.b  #0,d2
        sub.w   d7,d1
        sub.w   d7,d1
        move.l  a7,a0
        jsr     vdp_draw_string

        dbf     d7,instrument_patch_values_draw_interface_draw_operator_line_string_next_line

        lea     44(a7),a7                                                                             ; Return the bytes for the constructed string.

        ; Now that all the lines have been drawn, draw the extra things.

        ; Draw the captions along the bottom of the screen.
        move.l  #1,d0
        move.l  #14,d1
        move.b  #1,d2
        lea     (instrument_patch_values_interface_lower_caption_1),a0
        jsr     vdp_draw_string

        move.l  #1,d0
        move.l  #20,d1
        move.b  #1,d2
        lea     (instrument_patch_values_interface_lower_caption_2),a0
        jsr     vdp_draw_string

        lea     -8(a7),a7                                                                             ; Get eight bytes to construct more strings.

        move.l  a7,a0
        DBF_memory_fill 5,' ',a0,d1                                                                   ; Write 5 copies of ' ' into a0 using d1.
        move.b  #0,(a0)                                                                               ; There will be five max printable bytes then null.

        move.b  #0,d2
        move.b  (feedback_value),d0                                                                   ; d0 is FEEDBACK value as longword.
        lea     4(a7),a0
        jsr     place_right_aligned_number                                                            ; Place the right aligned number at cell 8 in string.
        move.w  #3,d0
        move.w  #16,d1
        move.l  a7,a0
        jsr     vdp_draw_string
        DBF_memory_fill 5,' ',a0,d1                                                                   ; Write 5 copies of ' ' into a0 using d1.

        move.b  (algorithm_value),d0                                                                  ; d0 is ALGORITHM value as longword.
        lea     4(a7),a0
        jsr     place_right_aligned_number
        move.w  #15,d0
        move.w  #16,d1
        move.l  a7,a0
        jsr     vdp_draw_string
        DBF_memory_fill 5,' ',a0,d1                                                                   ; Write 5 copies of ' ' into a0 using d1.

        move.b  (ams_value),d0                                                                        ; d0 is AMS value as longword.
        lea     4(a7),a0
        jsr     place_right_aligned_number
        move.w  #22,d0
        move.w  #16,d1
        move.l  a7,a0
        jsr     vdp_draw_string
        DBF_memory_fill 5,' ',a0,d1                                                                   ; Write 5 copies of ' ' into a0 using d1.

        move.b  (fms_value),d0                                                                        ; d0 is FMS value as longword.
        lea     4(a7),a0
        jsr     place_right_aligned_number
        move.w  #29,d0
        move.w  #16,d1
        move.l  a7,a0
        jsr     vdp_draw_string
        DBF_memory_fill 5,' ',a0,d1                                                                   ; Write 5 copies of ' ' into a0 using d1.

        move.b  (lfoen_value),d0                                                                      ; d0 is LFOEN flag.
        beq     instrument_patch_values_draw_interface_lfo_enable_is_blank
        move.b  #'\\',2(a7)
instrument_patch_values_draw_interface_lfo_enable_is_blank:
        move.w  #5,d0
        move.w  #22,d1
        move.l  a7,a0
        jsr     vdp_draw_string
        DBF_memory_fill 5,' ',a0,d1                                                                   ; Write 5 copies of ' ' into a0 using d1.

        move.b  (const_value),d0                                                                      ; d0 is CONST flag.
        beq     instrument_patch_values_draw_interface_const_enable_is_blank
        move.b  #'\\',2(a7)
instrument_patch_values_draw_interface_const_enable_is_blank:
        move.w  #31,d0
        move.w  #22,d1
        move.l  a7,a0
        jsr     vdp_draw_string
        DBF_memory_fill 5,' ',a0,d1                                                                   ; Write 5 copies of ' ' into a0 using d1.

        move.b  (lfo_value),d0                                                                        ; d0 is LFO value as longword.
        lea     4(a7),a0
        jsr     place_right_aligned_number
        move.w  #15,d0
        move.w  #22,d1
        move.l  a7,a0
        jsr     vdp_draw_string
        DBF_memory_fill 5,' ',a0,d1                                                                   ; Write 5 copies of ' ' into a0 using d1.


        ; Calculate the note string.
        move.l  #0,d1
        move.b  (note_value),d2
instrument_patch_values_draw_interface_calculate_note_repeat_subtraction:                             ; Divide note_value by 12 into d1.
        cmp.b   #12,d2
        blt     instrument_patch_values_draw_interface_calculate_note_divide_note_value_loop_ends
        sub.b   #12,d2
        add.b   #1,d1
        jmp     instrument_patch_values_draw_interface_calculate_note_repeat_subtraction
instrument_patch_values_draw_interface_calculate_note_divide_note_value_loop_ends:                    ; d1 contains note_value / 12. d2 contains note_value % 12.
        move.l  a7,a0
        add.b   #'0',d1
        move.b  d1,2(a0)                                                                              ; Third character is the octave number.
        move.b  #0,3(a0)                                                                              ; Fourth character is null.
        add.b   d2,d2
        move.b  d2,d0
        lea     (instrument_patch_values_interface_note_names),a1
        add.l   d0,a1
        move.b  (a1)+,0(a0)
        move.b  (a1)+,1(a0)
        move.w  #25,d0
        move.w  #22,d1
        move.b  #0,d2
        jsr     vdp_draw_string

        lea     8(a7),a7                                                                              ; Return the bytes for the constructed string.

        ; Calculate the position of the cursor.
        move.l  #0,d0
        move.b  (cursor_y),d0
        cmp.b   #4,d0
        bge     instrument_patch_values_draw_interface_cursor_on_lower_row
        ; Cursor y position is 16 multiple of cursor_y plus a constant.
        lsl.l   #4,d0
        add.l   #32,d0
        move.l  #0,d1
        move.b  (cursor_x),d1
        lsl.l   #1,d1
        lea     instrument_patch_values_interface_cursor_x_grid_positions,a0
        add.l   d1,a0
        move.w  (a0),d1
        jmp     instrument_patch_values_draw_interface_ready_to_draw_cursor
instrument_patch_values_draw_interface_cursor_on_lower_row:
        move.l  #128,d0
        cmp.b   #4,(cursor_y)
        beq     instrument_patch_values_draw_interface_cursor_y_established
instrument_patch_values_draw_interface_cursor_on_lowest_row:
        move.l  #176,d0
instrument_patch_values_draw_interface_cursor_y_established:
        move.l  #0,d1
        move.b  (cursor_x),d1
        lsl.l   #1,d1
        lea     instrument_patch_values_interface_cursor_x_lower_grid_positions,a0
        add.l   d1,a0
        move.w  (a0),d1
instrument_patch_values_draw_interface_ready_to_draw_cursor:
        ; Position the cursor sprites centred around d1,d0.
        add.l   #128,d0                                                                              ; Sprite display visible area begins at 128,128
        add.l   #128,d1
                                                                     
        ; Write the longword zero into MM_VDP_CONTROL to reset the high bits of VDP write address.
        move.l  #0,(MM_VDP_CONTROL)

        move.w  #(VDP_WCOMMAND_VRAM_WRITE|$3400),(MM_VDP_CONTROL)                                    ; Sprite table, entry zero.
        move.l  #MM_VDP_DATA,a6

        sub.l   #8,d0
        sub.l   #16,d1
        move.w  d0,(a6)
        move.w  #%0000000000000001,(a6)
        move.w  #%0001000000000000|(($01B5-'0')+'L'),(a6)  ; Use L for the cursor, hehe. Flip it around to make the different corners.
        move.w  d1,(a6)

        add.l   #16,d0
        move.w  d0,(a6)
        move.w  #%0000000000000010,(a6)
        move.w  #%0000000000000000|(($01B5-'0')+'L'),(a6)
        move.w  d1,(a6)

        add.l   #32,d1
        move.w  d0,(a6)
        move.w  #%0000000000000011,(a6)
        move.w  #%0000100000000000|(($01B5-'0')+'L'),(a6)
        move.w  d1,(a6)

        sub.l   #16,d0
        move.w  d0,(a6)
        move.w  #%0000000000000000,(a6)
        move.w  #%0001100000000000|(($01B5-'0')+'L'),(a6)
        move.w  d1,(a6)

        rts

instrument_patch_values_interface_parameter_caption:   ; 0123456789012345678901234567890123456789
        dc.b                                            "e a TL  AR D1R D1L D2R RR RS MUL DT1 SSG",0

instrument_patch_values_interface_lower_caption_1:     ; 01234567890123456789012345678901234567
        dc.b                                            "   FEEDBACK   ALGORITHM AMS    FMS",0

instrument_patch_values_interface_lower_caption_2:     ; 01234567890123456789012345678901234567
        dc.b                                            "    LFOEN        LFO   NOTE   CONST",0
        
instrument_patch_values_interface_note_names:
        dc.b    "C_CsD_DsE_F_FsG_GsA_AsB_"

        align   2

instrument_patch_values_interface_cursor_x_grid_positions:
        dc.w    8*0,8*2,8*5,8*8+4,8*12,8*16,8*20,8*23+4,8*26+4,8*30,8*34,8*38
instrument_patch_values_interface_cursor_x_lower_grid_positions:
        dc.w    8*7,8*19,8*26,8*33

        align   2
        
instrument_patch_values_interface_handle_controls:
        btst    #CONTROLLER_L_BIT_btst_l,(pad_1_pressed+1)
        beq     loop_l_not_pressed
        move.b  (cursor_x),d0
        cmp.b   #0,d0
        beq     editor_cursor_x_decrement_fails
        sub.b   #1,d0
        move.b  d0,(cursor_x)
editor_cursor_x_decrement_fails:
loop_l_not_pressed:
        btst    #CONTROLLER_R_BIT_btst_l,(pad_1_pressed+1)
        beq     loop_r_not_pressed
        move.b  (cursor_x),d0
        cmp.b   #11,d0
        beq     editor_cursor_x_increment_fails
        add.b   #1,d0
        move.b  d0,(cursor_x)
editor_cursor_x_increment_fails:
loop_r_not_pressed:
        btst    #CONTROLLER_U_BIT_btst_l,(pad_1_pressed+1)
        beq     loop_u_not_pressed
        move.b  (cursor_y),d0
        cmp.b   #0,d0
        beq     editor_cursor_y_decrement_fails
        sub.b   #1,d0
        move.b  d0,(cursor_y)
editor_cursor_y_decrement_fails:
loop_u_not_pressed:
        btst    #CONTROLLER_D_BIT_btst_l,(pad_1_pressed+1)
        beq     loop_d_not_pressed
        move.b  (cursor_y),d0
        cmp.b   #5,d0
        beq     editor_cursor_y_increment_fails
        add.b   #1,d0
        move.b  d0,(cursor_y)
editor_cursor_y_increment_fails:
loop_d_not_pressed:
        ; Replace cursor to safe place if it falls out of the operator grid.
        cmp.b   #4,(cursor_y)
        blt     editor_cursor_no_replace
        cmp.b   #3,(cursor_x)
        ble     editor_cursor_valid
        move.b  #3,(cursor_x)
        jmp     editor_cursor_replace_complete
editor_cursor_no_replace:
editor_cursor_valid:
editor_cursor_replace_complete:

        move.b  (cursor_y),d0
        move.b  (cursor_x),d1
        ; Get the maximum range of the cell at the cursor's location. (If it were in the top grid.)
        move.l  #0,d3
        move.b  d1,d3
        lea     (instrument_patch_values_interface_operator_value_ranges-2),a1
        add     d3,a1                                                                                 ; a1 points to max range of this cell, note that the first two don't have ranges.
        ; Loop through Y to get the total cell location, then get pointer to the value that's at the cursor's location.
        move.b  d0,d2
instrument_patch_values_interface_calculate_y_loop:
        beq     instrument_patch_values_interface_calculate_y_loop_complete
        add.b   #12,d3                                                                                ; Twelve operators per line.
        sub.b   #1,d2
        jmp     instrument_patch_values_interface_calculate_y_loop
instrument_patch_values_interface_calculate_y_loop_complete:                                          ; Cursor position = x + 12 * y in d3.
        lea     (operator_values),a0
        add.l   d3,a0                                                                                 ; a0 points to current value of this cell.
        ; If its in the upper grid:
        cmp.b   #4,d0
        beq     instrument_patch_values_interface_cursor_in_lower_section_1
        bgt     instrument_patch_values_interface_cursor_in_lower_section_2
        ; The cursor is in the top grid.
        ; Check for the two left columns.
        cmp.b   #2,d1
        blt     instrument_patch_values_interface_cursor_in_upper_left_section
instrument_patch_values_interface_cursor_in_upper_right_section:
        ; The cursor is in the upper right section.
        btst    #CONTROLLER_A_BIT_btst_l,(pad_1_curr+1)
        beq     instrument_patch_values_interface_cursor_in_upper_right_section_a_not_pressed
        move.b  (a0),d4
        cmp.b   (a1),d4
        beq     instrument_patch_values_interface_cursor_in_upper_right_section_a_pressed_cannot_increment
        add.b   #1,d4
        move.b  d4,(a0)
instrument_patch_values_interface_cursor_in_upper_right_section_a_pressed_cannot_increment:
instrument_patch_values_interface_cursor_in_upper_right_section_a_not_pressed:
        btst    #CONTROLLER_B_BIT_btst_l,(pad_1_curr+1)
        beq     instrument_patch_values_interface_cursor_in_upper_right_section_b_not_pressed
        move.b  (a0),d4
        beq     instrument_patch_values_interface_cursor_in_upper_right_section_b_pressed_cannot_decrement
        sub.b   #1,d4
        move.b  d4,(a0)
instrument_patch_values_interface_cursor_in_upper_right_section_b_pressed_cannot_decrement:
instrument_patch_values_interface_cursor_in_upper_right_section_b_not_pressed:
        jmp     instrument_patch_values_interface_cursor_a_b_handling_complete
instrument_patch_values_interface_cursor_in_upper_left_section:
        ; The cursor is in the upper left section.
        btst    #CONTROLLER_A_BIT_btst_l,(pad_1_pressed+1)
        beq     instrument_patch_values_interface_cursor_in_upper_left_section_a_not_pressed
        ; If we're in column zero, we need to go to $FF.
        ; If we're in column one, we need to go to $80.
        move.b  #$FF,d5
        btst    #0,d1
        beq     instrument_patch_values_interface_cursor_in_upper_left_section_column_zero
        move.b  #$80,d5
instrument_patch_values_interface_cursor_in_upper_left_section_column_zero:
        eor.b   d5,(a0)
instrument_patch_values_interface_cursor_in_upper_left_section_a_not_pressed:
        jmp     instrument_patch_values_interface_cursor_a_b_handling_complete
instrument_patch_values_interface_cursor_in_lower_section_1:
        ; We have the cursor pointer in a0.
        move.b  d1,d3
        lea     (instrument_patch_values_interface_lower_value_ranges),a1
        add     d3,a1                                                                          ; a1 points to maximum range for this cell.
        btst    #CONTROLLER_A_BIT_btst_l,(pad_1_pressed+1)
        beq     instrument_patch_values_interface_cursor_in_lower_section_1_a_not_pressed
        move.b  (a0),d4
        cmp.b   (a1),d4
        beq     instrument_patch_values_interface_cursor_in_lower_section_1_a_pressed_cannot_increment
        add.b   #1,d4
        move.b  d4,(a0)
instrument_patch_values_interface_cursor_in_lower_section_1_a_pressed_cannot_increment:
instrument_patch_values_interface_cursor_in_lower_section_1_a_not_pressed:
        btst    #CONTROLLER_B_BIT_btst_l,(pad_1_pressed+1)
        beq     instrument_patch_values_interface_cursor_in_lower_section_1_b_not_pressed
        move.b  (a0),d4
        beq     instrument_patch_values_interface_cursor_in_lower_section_1_b_pressed_cannot_decrement
        sub.b   #1,d4
        move.b  d4,(a0)
instrument_patch_values_interface_cursor_in_lower_section_1_b_pressed_cannot_decrement:
instrument_patch_values_interface_cursor_in_lower_section_1_b_not_pressed:
        jmp     instrument_patch_values_interface_cursor_a_b_handling_complete
instrument_patch_values_interface_cursor_in_lower_section_2:
        ; Cursor x in d1.
        cmp.b   #3,d1
        beq     instrument_patch_values_interface_cursor_in_lower_section_2_const_value
        cmp.b   #1,d1
        beq     instrument_patch_values_interface_cursor_in_lower_section_2_lfo_value
        bgt     instrument_patch_values_interface_cursor_in_lower_section_2_note
        ; The cursor on lfo enable.
        btst    #CONTROLLER_A_BIT_btst_l,(pad_1_pressed+1)
        beq     instrument_patch_values_interface_cursor_in_lower_section_2_lfo_enable_a_not_pressed
        eor.b   #$FF,(lfoen_value)
        move.b  #1,(lfoen_value_invalidated)
instrument_patch_values_interface_cursor_in_lower_section_2_lfo_enable_a_not_pressed:
        jmp     instrument_patch_values_interface_cursor_a_b_handling_complete
instrument_patch_values_interface_cursor_in_lower_section_2_lfo_value:
        btst    #CONTROLLER_A_BIT_btst_l,(pad_1_pressed+1)
        beq     instrument_patch_values_interface_cursor_in_lower_section_2_lfo_value_a_not_pressed
        cmp.b   #7,(lfo_value)
        beq     instrument_patch_values_interface_cursor_in_lower_section_2_lfo_value_a_pressed_cannot_increment
        add.b   #1,(lfo_value)
instrument_patch_values_interface_cursor_in_lower_section_2_lfo_value_a_pressed_cannot_increment:
instrument_patch_values_interface_cursor_in_lower_section_2_lfo_value_a_not_pressed:
        btst    #CONTROLLER_B_BIT_btst_l,(pad_1_pressed+1)
        beq     instrument_patch_values_interface_cursor_in_lower_section_2_lfo_value_b_not_pressed
        cmp.b   #0,(lfo_value)
        beq     instrument_patch_values_interface_cursor_in_lower_section_2_lfo_value_b_pressed_cannot_decrement
        sub.b   #1,(lfo_value)
instrument_patch_values_interface_cursor_in_lower_section_2_lfo_value_b_pressed_cannot_decrement:
instrument_patch_values_interface_cursor_in_lower_section_2_lfo_value_b_not_pressed:
        jmp     instrument_patch_values_interface_cursor_a_b_handling_complete
instrument_patch_values_interface_cursor_in_lower_section_2_note:
        btst    #CONTROLLER_A_BIT_btst_l,(pad_1_pressed+1)
        beq     instrument_patch_values_interface_cursor_in_lower_section_2_note_a_not_pressed
        cmp.b   #8*12-1,(note_value)
        beq     instrument_patch_values_interface_cursor_in_lower_section_2_note_a_pressed_cannot_increment
        add.b   #1,(note_value)
instrument_patch_values_interface_cursor_in_lower_section_2_note_a_pressed_cannot_increment:
instrument_patch_values_interface_cursor_in_lower_section_2_note_a_not_pressed:
        btst    #CONTROLLER_B_BIT_btst_l,(pad_1_pressed+1)
        beq     instrument_patch_values_interface_cursor_in_lower_section_2_note_b_not_pressed
        cmp.b   #0,(note_value)
        beq     instrument_patch_values_interface_cursor_in_lower_section_2_note_b_pressed_cannot_decrement
        sub.b   #1,(note_value)
instrument_patch_values_interface_cursor_in_lower_section_2_note_b_pressed_cannot_decrement:
instrument_patch_values_interface_cursor_in_lower_section_2_note_b_not_pressed:
        jmp     instrument_patch_values_interface_cursor_a_b_handling_complete
instrument_patch_values_interface_cursor_in_lower_section_2_const_value:
        btst    #CONTROLLER_A_BIT_btst_l,(pad_1_pressed+1)
        beq     instrument_patch_values_interface_cursor_in_lower_section_2_const_value_a_not_pressed
        eor.b   #$FF,(const_value)
instrument_patch_values_interface_cursor_in_lower_section_2_const_value_a_not_pressed:
        jmp     instrument_patch_values_interface_cursor_a_b_handling_complete
instrument_patch_values_interface_cursor_a_b_handling_complete:

        btst    #CONTROLLER_C_BIT_btst_l,(pad_1_pressed+1)
        beq     instrument_patch_values_interface_c_not_pressed
        jsr     YM2612_send_note_off
        jsr     instrument_patch_values_load_into_YM2612
        jsr     YM2612_send_note_on
instrument_patch_values_interface_c_not_pressed:

        btst    #CONTROLLER_S_BIT_btst_l,(pad_1_pressed+1)
        beq     instrument_patch_values_interface_s_not_pressed
        jsr     YM2612_send_note_off
instrument_patch_values_interface_s_not_pressed:

        rts

instrument_patch_values_interface_operator_value_ranges:
        dc.b    127,31,31,15,31,15,3,15,7,15

instrument_patch_values_interface_lower_value_ranges:
        dc.b    7,7,3,7



        align   2


; We're going to get a fine collection of system library routines.
; Plonk them together and then maybe we can refactor them into a separate file later.
; (It's 16th January 2014 today, in case future Matt comes back and sees that he never
; bothered to refactor the controller reading code WHUPS.)

; Reset the controllers to known unpressed state.
controllers_reset:
        move.l  #0,pad_1_curr                    ; This should clear both low and high words! (Curr and prev are stored consecutively.)
        move.l  #0,pad_2_curr
        jsr     controllers_derive
        rts

controllers_read:
        ; We need to disable the Z80 here!!
        interrupts_disable
        z80_bus_request_engage
        z80_wait_bus_available

        lea     MM_CONTROLLER_1_DATA+1,a0                      ; a0 is the memory mapped register for the data source.
        lea     pad_1_curr,a1                                  ; a1 is the pad status struct in RAM.
        
        move.b  #2,d3                                          ; Go through two pads.

controllers_read_next_controller:
        move.w  (a1),2(a1)                                     ; Copy current state to previous state.

        ; We want to read both controller 1 and controller 2. We can (should) do this in a loop because the mm registers are close.
        move.b  #$40,MM_CONTROLLER_DATA_TO_CONTROL_OFFSET(a0)  ; Set direction of bits of port 1.
        move.l  #0,d0                                          ; d0 will contain activated bitmask as we construct it.
        move.l  d0,d1                                          ; d1 contains in progress read bits.
        move.l  d0,d2                                          ; d2 will be used to test for 6-button pad telltale.

        ; We're going to try and read the controller port in such a way that's compatible with both the 3 button and 6 button pad.
        move.b  #$40,(a0)                                      ; Make TH high.
        nop                                                    ; Allow the controller to respond.
        nop
        move.b  (a0),d0                                        ; d0 = 00000000x1CBRLDU
        and.b   #%00111111,d0                                  ; d0 = 0000000000CBRLDU

        move.b  #$00,(a0)                                      ; Make TH low.
        nop                                                    ; Allow the controller to respond.
        nop
        move.b  (a0),d1                                        ; d1 = 00000000x0SAxxxx
        and.b   #%00110000,d1                                  ; d1 = 0000000000SA0000
        lsl.b   #2,d1                                          ; d1 = 00000000SA000000
        or.b    d1,d0                                          ; d0 = 00000000SACBRLDU --- note that these are active LOW!
        not.b   d0                                             ; d0 = 00000000SACBRLDU --- now these are active HIGH (which is what I want)

        move.b  #$40,(a0)                                      ; Make TH high.
        nop                                                    ; Allow the controller to respond.
        nop
        move.b  #$00,(a0)                                      ; Make TH low.
        nop                                                    ; Allow the controller to respond.
        nop
        move.b  #$40,(a0)                                      ; Make TH high.
        nop                                                    ; Allow the controller to respond.
        nop
        move.b  (a0),d1                                        ; d1 = 00000000x1xxXYZM
        and.b   #%00001111,d1                                  ; d1 = 000000000000XYZM --- note that these are active LOW!
        eor.b   #%00001111,d1                                  ; d1 = 000000000000XYZM --- now these are active HIGH (which is what I want)
        move.b  #$00,(a0)                                      ; Make TH low.
        nop                                                    ; Allow the controller to respond.
        nop
        move.b  (a0),d2                                        ; d2 = 00000000x0xx????
        ; d2 will contain xxxx1111 if we're using a six button pad. Or you're pressing left and right simultaneously...?
        and.b   #%00001100,d2                                  ; If the register is empty after this, we're on state 2 of the 3 button pad, otherwise we're on 6 of the 6 button pad.
        beq     controllers_read_not_using_six_button_pad
        ; We're using a six button pad.
        lsl.w   #8,d1                                          ; d1 = 0000XYZM00000000
        or.w    d1,d0                                          ; d0 = 0000XYZMSACBRLDU
        or.w    #%1000000000000000,d0                          ; d0 = 6000XYZMSACBRLDU --- all active high!
controllers_read_not_using_six_button_pad:
        move.w  d0,(a1)

        lea     MM_CONTROLLER_DATA_SOURCE_STRIDE(a0),a0        ; Go to the next data source memory mapped register location
        lea     PAD_STATUS_STRUCT_STRIDE(a1),a1                ; Go to the next pad status struct
                                                                   
        sub.b   #1,d3
        bne     controllers_read_next_controller

        ; We need to enable the Z80 again if that's what we're doing.
        z80_bus_request_disengage
        interrupts_enable

        rts

controllers_derive:
        lea     pad_1_curr,a0                           ; Use a0 as reading and writing cursor.

        move.b  #2,d5                                   ; Loop through two controllers.
controllers_derive_next_controller:

        move.w  (a0)+,d0                                ; Load current into d0
        move.w  (a0)+,d1                                ; Load previous into d1

        move.w  d0,d2
        not.w   d2                                      ; d2 = !curr
        move.w  d1,d3
        not.w   d3                                      ; d3 = !prev

        move.w  d0,d4
        and.w   d3,d4                                   ; d4 =  curr & !prev = PRESSED
        move.w  d4,(a0)+

        move.w  d0,d4
        and.w   d1,d4                                   ; d4 =  curr &  prev = HELD
        move.w  d4,(a0)+

        move.w  d2,d4
        and.w   d1,d4                                   ; d4 = !curr &  prev = RELEASED
        move.w  d4,(a0)+

        move.w  d2,d4
        and.w   d3,d4                                   ; d4 = !curr & !prev = IDLE
        move.w  d4,(a0)+

        sub.b   #1,d5

        bne     controllers_derive_next_controller

        rts

        include "routines_maths.68k.asm"
